//
//  TableViewController.swift
//  Correct
//
//  Created by Mark Meretzky on 1/12/15.
//  Copyright (c) 2015 Mark Meretzky. All rights reserved.
//

import UIKit;

class TableViewController: UITableViewController, UITextFieldDelegate {
	let cellReuseIdentifier: String = "correct";
	
	var lines: [String] = [
		"drunkeness",
		"equiptment",
		"greatful",
		"harrass",
		"indispensible",
		"noticeable",
		"seperate",
		"supercede",
		"untill",
		"wierd",
		"Poughkeepsie",
		"Schenectady",
		"Rensselaer"
	];
	
	//The currenly selected cell, if there is one.
	var selected: NSIndexPath? = nil;

	required init(coder aDecoder: NSCoder) {
		super.init(nibName: nil, bundle: nil);
	}

	override func viewDidLoad() {
		super.viewDidLoad();
		tableView.registerClass(UITableViewCell.self, forCellReuseIdentifier: cellReuseIdentifier);

		// Uncomment the following line to preserve selection between presentations
		// clearsSelectionOnViewWillAppear = false;

		// Uncomment the following line to display an Edit button in the navigation bar for this view controller.
		// navigationItem.rightBarButtonItem = editButtonItem();
	}

	override func didReceiveMemoryWarning() {
		super.didReceiveMemoryWarning()
		// Dispose of any resources that can be recreated.
	}

	// MARK: - Table view data source

	override func numberOfSectionsInTableView(tableView: UITableView) -> Int {
		// Return the number of sections.
		return 1;
	}

	override func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
		// #warning Incomplete method implementation.
		// Return the number of rows in the section.
		return lines.count;
	}

	override func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
		let cell = tableView.dequeueReusableCellWithIdentifier(cellReuseIdentifier, forIndexPath: indexPath) as UITableViewCell

		// Configure the cell...
		cell.textLabel!.text = lines[indexPath.row];
		return cell;
	}

	override func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
		if selected != nil {
			//Arrive here if user was already editing one cell and then touched another.
			//Stop editing the first cell before we begin to edit the second one.
			let cell: UITableViewCell? = tableView.cellForRowAtIndexPath(selected!);
			let textField: UITextField = cell!.contentView.subviews.last as UITextField;
			textFieldShouldReturn(textField);
			textFieldDidEndEditing(textField);
		}
		selected = indexPath;

		//Add a UITextField to the selected cell.
		//The initial text of the text field must coincide with the text of the textLabel.
		let cell: UITableViewCell? = tableView.cellForRowAtIndexPath(indexPath);
		if cell == nil {
			println("couldn't find cell \(indexPath)");
			return;
		}
		
		//Create a text field that looks exactly like the textLabel.
		let font: UIFont = cell!.textLabel!.font;
		let dy: CGFloat = (cell!.textLabel!.bounds.size.height - font.lineHeight) / 2;
		let frame: CGRect = CGRectMake(
			cell!.textLabel!.frame.origin.x,
			cell!.textLabel!.frame.origin.y + dy,
			cell!.textLabel!.bounds.size.width,
			cell!.textLabel!.bounds.size.height - dy
		);
		let textField: UITextField = UITextField(frame: cell!.textLabel!.frame);
		textField.frame.origin.y += 0.5;	//kludge
		textField.backgroundColor = cell!.textLabel!.backgroundColor;
		textField.textColor = cell!.textLabel!.textColor;
		textField.font = font;
		textField.text = cell!.textLabel!.text;
		textField.autocapitalizationType = UITextAutocapitalizationType.None;
		textField.autocorrectionType = UITextAutocorrectionType.No;
		textField.delegate = self;

		cell!.textLabel!.text = nil;
		cell!.contentView.addSubview(textField);
		textField.becomeFirstResponder();   //Show the keyboard.
	}

	//Called when return key is pressed, or when user starts editing a different cell.
	//Decide if the app should accept this input and hide the keyboard.

	func textFieldShouldReturn(textField: UITextField) -> Bool {
		textField.resignFirstResponder();	//Hide keyboard.
		return true;	//The text field should do its default behavior.
	}

	//Called when we're done editing the text in a cell.
	//Process the text that was input.

	func textFieldDidEndEditing(textField: UITextField) {
		if selected != nil {
			lines[selected!.row] = textField.text;
			let cell: UITableViewCell? = tableView.cellForRowAtIndexPath(selected!);
			cell!.textLabel!.text = textField.text;
			textField.removeFromSuperview();
			tableView.deselectRowAtIndexPath(selected!, animated: true); //Remove the gray.
			selected = nil;
		}
	}

	/*
	// Override to support conditional editing of the table view.
	override func tableView(tableView: UITableView, canEditRowAtIndexPath indexPath: NSIndexPath) -> Bool {
		// Return false if you do not want the specified item to be editable.
		return true;
	}
	*/

	/*
	// Override to support editing the table view.
	override func tableView(tableView: UITableView, commitEditingStyle editingStyle: UITableViewCellEditingStyle, forRowAtIndexPath indexPath: NSIndexPath) {
		if editingStyle == .Delete {
			// Delete the row from the data source
			tableView.deleteRowsAtIndexPaths([indexPath], withRowAnimation: .Fade)
		} else if editingStyle == .Insert {
			// Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
		}
	}
	*/

	/*
	// Override to support rearranging the table view.
	override func tableView(tableView: UITableView, moveRowAtIndexPath fromIndexPath: NSIndexPath, toIndexPath: NSIndexPath) {

	}
	*/

	/*
	// Override to support conditional rearranging of the table view.
	override func tableView(tableView: UITableView, canMoveRowAtIndexPath indexPath: NSIndexPath) -> Bool {
		// Return false if you do not want the item to be re-orderable.
		return true;
	}
	*/

	/*
	// MARK: - Navigation

	// In a storyboard-based application, you will often want to do a little preparation before navigation
	override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
		// Get the new view controller using [segue destinationViewController].
		// Pass the selected object to the new view controller.
	}
	*/

}
